<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>ExtendedPort2 xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/components/modellibs/core/mappingrules/ExtendedPort2.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.components.modellibs.core.mappingrules;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.profile.IMappingRule;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.profile.PortMapUtil;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.PortUtils;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.component.PrefixConstants;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Interface;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Operation;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Port;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <em class="jxr_javadoccomment"> * An extended Port in the sense of the DDS4CCM standard: a port typed with a component</em>
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <em class="jxr_javadoccomment"> * type (the extended port, not the data type that is transported). Since the component typing</em>
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <em class="jxr_javadoccomment"> * the port can have multiple provided and required</em>
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <em class="jxr_javadoccomment"> * ports, the ports are implicitly owned by the port. Conjugation on the level of an extended</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment"> * port level will conjugate all ports of the component typing the port.</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment"> * The derived interface that is provided will allow a caller to access individual ports. It</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment"> * is therefore a reference to the interfaces get_&lt;portName&gt; operations provided by a</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment"> * component.</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment"> * The derived interface that is required is identical, except for a conjugation on the</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment"> * extended port level.</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <em class="jxr_javadoccomment"> * What is the difference to ExtendedPort?</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/modellibs/core/mappingrules/ExtendedPort2.html">ExtendedPort2</a> <strong class="jxr_keyword">implements</strong> IMappingRule {
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String CONJ_PREFIX = <span class="jxr_string">"C2_"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String NORM_PREFIX = <span class="jxr_string">"N2_"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  	@Override
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  	<strong class="jxr_keyword">public</strong> Type calcDerivedType(org.eclipse.papyrus.designer.components.FCM.Port p, <strong class="jxr_keyword">boolean</strong> update) {
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  	
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  		Type type = p.getType();
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  		<strong class="jxr_keyword">if</strong> (!(type instanceof Class)) {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		}
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  		Class extendedPort = (Class) type;
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  		<strong class="jxr_keyword">boolean</strong> isConjugated = p.getBase_Port().isConjugated();
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  		String prefix = isConjugated ? CONJ_PREFIX : NORM_PREFIX;
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  		Class derivedClass = PortMapUtil.getDerivedClass(p, prefix, update);
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  		Interface providedInterface = PortMapUtil.getDerivedInterface(p, prefix, update);
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  		Interface requiredInterface = PortMapUtil.getDerivedInterface(p, prefix, update);
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  		<strong class="jxr_keyword">if</strong> (!update) {
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  			<strong class="jxr_keyword">return</strong> derivedClass;
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  		}
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  		<strong class="jxr_keyword">if</strong> (derivedClass == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  		}
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  		<strong class="jxr_keyword">for</strong> (Port port : extendedPort.getOwnedPorts()) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			<em class="jxr_comment">// if the extended port is conjugated, each of the provided/required are (implicitly)</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  			<em class="jxr_comment">// conjugated [TODO: is PortUtils aware of it? - probably yes]</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  			Interface reqIntf = PortUtils.getRequired(port);
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  			<strong class="jxr_keyword">if</strong> (reqIntf != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  				String name = PrefixConstants.getP_Prefix + port.getName();
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  				<em class="jxr_comment">// check whether operation already exists. Create, if not</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  				Operation derivedOperation = requiredInterface.getOperation(name, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  				<strong class="jxr_keyword">if</strong> (derivedOperation == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  					derivedOperation = requiredInterface.createOwnedOperation(name, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  				}
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			}
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  			
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  			Interface provIntf = PortUtils.getProvided(port);
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  			
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  			<strong class="jxr_keyword">if</strong> (provIntf != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  				String name = PrefixConstants.getConnQ_Prefix + port.getName();
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  				<em class="jxr_comment">// check whether operation already exists. Create, if not</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  				Operation derivedOperation = providedInterface.getOperation(name, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  				<strong class="jxr_keyword">if</strong> (derivedOperation == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  					derivedOperation = providedInterface.createOwnedOperation(name, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  				}
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  			}
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  		}
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  		<strong class="jxr_keyword">return</strong> derivedClass;
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  	}
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 	@Override
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> needsUpdate(org.eclipse.papyrus.designer.components.FCM.Port p) {
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		<strong class="jxr_keyword">return</strong> needsUpdate(p, false) ||
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 				needsUpdate(p, <strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 	}
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> needsUpdate(org.eclipse.papyrus.designer.components.FCM.Port p, <strong class="jxr_keyword">boolean</strong> isConjugated) {
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		Type type = p.getBase_Port().getType();
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 		<strong class="jxr_keyword">if</strong> (!(type instanceof Class)) {
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 			<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 		}
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		Class extendedPort = (Class) type;
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		String prefix = isConjugated ? CONJ_PREFIX : NORM_PREFIX;
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		Interface derivedInterface = PortMapUtil.getDerivedInterface(p, prefix);
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		<strong class="jxr_keyword">if</strong> (derivedInterface == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		}
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		<strong class="jxr_keyword">for</strong> (Port port : extendedPort.getOwnedPorts()) {
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 			<em class="jxr_comment">// if the extended port is conjugated, each of the provided/required are (implicitly)</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 			<em class="jxr_comment">// conjugated [TODO: is PortUtils aware of it? - probably yes]</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 			Interface provIntf = (isConjugated) ?
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 					PortUtils.getRequired(port) :
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 					PortUtils.getProvided(port);
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 			<strong class="jxr_keyword">if</strong> (provIntf != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 				String name = PrefixConstants.getP_Prefix + port.getName();
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 				<em class="jxr_comment">// check whether operation already exists. Create, if not</em>
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 				Operation derivedOperation = derivedInterface.getOperation(name, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 				<strong class="jxr_keyword">if</strong> (derivedOperation == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 					<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 				}
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 			}
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 		}
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 	}
<a class="jxr_linenumber" name="L138" href="#L138">138</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
